
#include "sfr_r8m12a.h"
#include "pic.h"
#include "wait.h"

#pragma SECTION program program_dataflash	// ȉ̊֐f[^tbVɔzu
 
void pic24enticsp(void)
{
	pic16enticsp();
	MCLR=1;
	wait10us(10);
	MCLR=0;
	wait10us(10);	// P18 40ns ȏ
	outdata24(16,0xC2B2);	// 4D43:0100 1101 0100 0011 -t 1100 0010 1011 0010:C2B2
	outdata24(16,0x8A12);	// 4851:0100 1000 0101 0001 -t 1000 1010 0001 0010:8A12
	waitms(1);	// P19 1msȏ
	MCLR=1;
	waitms(30);	// P7 25msȏ
	outdata24(9,0);	// ŏ4rbgȂ9rbgȂ̂ŁAłNOPoĂ
	outdata24(24,0);
}

void pic24exiticsp(void)
{
	waitms(10);	// P16 0sȏ
	MCLR=0;
	PGD=0;
	PGC=0;
	waitms(10);
	MCLR=1;
}

void outdata24(unsigned char bit, unsigned short data)
{
	PGD_PINOUT();
	asm("nop");
	for(;bit!=0; bit--)
	{
		PGC=0;	// NbN̎RJ0.04usȏ
		if((data&1)==0) PGD=0;
		else PGD=1;
		PGC=1;	// NbN̗オŃf[^L
		data=data>>1;
	}
	PGC=0;
	PGD=0;
}

unsigned short readdata24(unsigned char bit)
{
	unsigned short shift;
	unsigned short data=0;
	shift=(1<<(bit-1));
	PGD_PININ();
	asm("nop");
	for(;bit!=0; bit--)
	{
		PGC=0;
		data=(data>>1);
		if(PGD==1)data+=shift;
		PGC=1;
	}
	PGC=0;
	PGD_PINOUT();
	return data;
}

void sixserialexe(unsigned long data)	// long32rbg
{
	outdata24(4,0);
	//wait10us(0);	// P4 40nsȏ
	outdata24(16,(data)&0xFFFF);
	outdata24( 8,(data>>16)&0xFF);
	//wait10us(0);	// P4A 40nsȏ
}

unsigned short regoutserialexe(void)
{
	unsigned short data;
	outdata24(4,1);
	//wait10us(0);	// P4 40nsȏ
	outdata24(8,0);
	//wait10us(0);	// P5 20nsȏ
	data=readdata24(16);
	//wait10us(0);	// P4A 40nsȏ
	return data;
}

void outdata(unsigned char bit, unsigned short data)
{
	PGD_PINOUT();
	asm("nop");
	for(;bit!=0; bit--)
	{
		PGC=1;	// NbN̎RJ0.2usȏ
		if((data&1)==0) PGD=0;
		else PGD=1;
		PGC=0;	// NbN̗Ńf[^L
		data=data>>1;
	}
	PGD=0;
}

unsigned short readdata(unsigned char bit)
{
	unsigned short shift;
	unsigned short data=0;
	shift=(1<<(bit-1));
	PGD_PININ();
	asm("nop");
	for(;bit!=0; bit--)
	{
		data=(data>>1);
		PGC=1;
		if(PGD==1)data+=shift;
		PGC=0;	// NbN̗Ńf[^L
	}
	PGD_PINOUT();
	return data;
}

void pic16enticsp(void)
{
	MCLR_PINOUT();
	PGD_PINOUT();
	PGC_PINOUT();
	PGD=0;
	PGC=0;
	MCLR=0;
	
	// LV-ICSP MODE ENTRY
	wait10us(10);	// 100nsȏ
	MCLR=1;
	wait10us(10);	// 5usȏ
}

void loadconfig(void)
{
	outdata(6,0);	// load config
	outdata(16,0);	// 16rbg_~[̃f[^𑗂
}

void loadPGM(unsigned short data)
{
	data=(data<<1)&0xFFFE;
	outdata(6,0x02);	// Load Data for Program Memory
	outdata(16,data);
}

unsigned short readPGM(void)
{
	unsigned short data;
	outdata(6,0x04);
	data=readdata(16);
	data=(data>>1)&0x3FFF;	// 0011 1111 1111 1111
	return data;
}

void incaddress(void)
{
	outdata(6,0x06);	// Increment Address
}

void endprogramming(unsigned char wait)
{
	waitms(wait);
	outdata(6,0x17);	// End Programming
}

// ubNTCY
// vO 32[h
// f[^ 1oCgiPĈ1oCgj
void beginerase(void)
{
	outdata(6,0x08);	// Begin Erase
				// tprog2 4.5VȏȂ 1ms 4.5VȉȂ 2ms
	endprogramming(2);
}

void beginprogrammingonly(void)
{
	outdata(6,0x18);	// Begin Programming Only Cycle
				// tprog1 4.5VȏȂ 1ms 4.5VȉȂ 2ms// Wait tprog1
	endprogramming(2);
}

void bulkerasePGM(void)
{
	outdata(6,0x09);
	outdata(6,0x08);	// Begin Erase
	endprogramming(10);
}

void bulkeraseDAT(void)
{
	outdata(6,0x0B);
	outdata(6,0x08);	// Begin Erase
	endprogramming(10);
}

void chiperase(void)
{
	outdata(6,0x1F);
	waitms(10);
}

void loadDAT(unsigned char data)
{
	unsigned short a;
	a=data;
	a=(a<<1)&0x01FE;	// 0000 000x xxxx xxx0
	outdata(6,0x03);
	outdata(16,a);
}

unsigned char readDAT(void)
{
	unsigned short data;
	outdata(6,0x05);
	data=readdata(16);
	data=(data>>1)&0x00FF;
	return (unsigned char)data;
}

#pragma SECTION program program